Index: /pjproject/trunk/pjlib-util/include/pjlib-util/scanner.h
===================================================================
--- /pjproject/trunk/pjlib-util/include/pjlib-util/scanner.h	(revision 621)
+++ /pjproject/trunk/pjlib-util/include/pjlib-util/scanner.h	(revision 622)
@@ -180,5 +180,5 @@
     /** Auto-skip new lines.
      */
-    PJ_SCAN_AUTOSKIP_NEWLINE = 4,
+    PJ_SCAN_AUTOSKIP_NEWLINE = 4
 };
 
Index: /pjproject/trunk/pjlib/include/pj/compat/cc_gcc.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/compat/cc_gcc.h	(revision 621)
+++ /pjproject/trunk/pjlib/include/pj/compat/cc_gcc.h	(revision 622)
@@ -35,13 +35,21 @@
 
 
-#define PJ_INLINE_SPECIFIER	static inline
 #define PJ_THREAD_FUNC	
 #define PJ_NORETURN		
-#define PJ_ATTR_NORETURN	__attribute__ ((noreturn))
 
 #define PJ_HAS_INT64		1
 
-typedef long long pj_int64_t;
-typedef unsigned long long pj_uint64_t;
+#ifdef __STRICT_ANSI__
+  #include <inttypes.h> 
+  typedef int64_t		pj_int64_t;
+  typedef uint64_t		pj_uint64_t;
+  #define PJ_INLINE_SPECIFIER	static __inline
+  #define PJ_ATTR_NORETURN	
+#else
+  typedef long long		pj_int64_t;
+  typedef unsigned long long	pj_uint64_t;
+  #define PJ_INLINE_SPECIFIER	static inline
+  #define PJ_ATTR_NORETURN	__attribute__ ((noreturn))
+#endif
 
 #define PJ_INT64(val)		val##LL
Index: /pjproject/trunk/pjlib/include/pj/ctype.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/ctype.h	(revision 621)
+++ /pjproject/trunk/pjlib/include/pj/ctype.h	(revision 622)
@@ -63,5 +63,5 @@
  *              an ASCII character.
  */
-PJ_INLINE(int) pj_isascii(int c) { return isascii(c); }
+PJ_INLINE(int) pj_isascii(int c) { return c<128 && c>=0; }
 
 /** 
Index: /pjproject/trunk/pjlib/include/pj/file_io.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/file_io.h	(revision 621)
+++ /pjproject/trunk/pjlib/include/pj/file_io.h	(revision 622)
@@ -62,5 +62,5 @@
     PJ_O_RDWR       = 0x1103,   /**< Open file for reading and writing. 
                                      File will be truncated.            */
-    PJ_O_APPEND     = 0x1108,   /**< Append to existing file.           */
+    PJ_O_APPEND     = 0x1108    /**< Append to existing file.           */
 };
 
@@ -72,5 +72,5 @@
     PJ_SEEK_SET     = 0x1201,   /**< Offset from beginning of the file. */
     PJ_SEEK_CUR     = 0x1202,   /**< Offset from current position.      */
-    PJ_SEEK_END     = 0x1203,   /**< Size of the file plus offset.      */
+    PJ_SEEK_END     = 0x1203    /**< Size of the file plus offset.      */
 };
 
Index: /pjproject/trunk/pjlib/include/pj/ioqueue.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/ioqueue.h	(revision 621)
+++ /pjproject/trunk/pjlib/include/pj/ioqueue.h	(revision 622)
@@ -220,5 +220,5 @@
 #if defined(PJ_HAS_TCP) && PJ_HAS_TCP != 0
     PJ_IOQUEUE_OP_ACCEPT	= 64,	/**< accept() operation.    */
-    PJ_IOQUEUE_OP_CONNECT	= 128,	/**< connect() operation.   */
+    PJ_IOQUEUE_OP_CONNECT	= 128	/**< connect() operation.   */
 #endif	/* PJ_HAS_TCP */
 } pj_ioqueue_operation_e;
Index: /pjproject/trunk/pjlib/include/pj/log.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/log.h	(revision 621)
+++ /pjproject/trunk/pjlib/include/pj/log.h	(revision 622)
@@ -78,5 +78,5 @@
     PJ_LOG_HAS_SENDER	  =  64, /**< Include sender in the log [yes].	     */
     PJ_LOG_HAS_NEWLINE	  = 128, /**< Terminate each call with newline [yes].*/
-    PJ_LOG_HAS_CR	  = 256, /**< Include carriage return [no].	     */
+    PJ_LOG_HAS_CR	  = 256  /**< Include carriage return [no].	     */
 };
 
@@ -250,5 +250,5 @@
  */
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /*
  * Log functions implementation prototypes.
Index: /pjproject/trunk/pjlib/include/pj/os.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/os.h	(revision 621)
+++ /pjproject/trunk/pjlib/include/pj/os.h	(revision 622)
@@ -34,5 +34,5 @@
 
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * @defgroup PJ_THREAD Threads
@@ -227,5 +227,5 @@
  */
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * @defgroup PJ_TLS Thread Local Storage.
@@ -272,5 +272,5 @@
 
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * @defgroup PJ_ATOMIC Atomic Variables
@@ -383,5 +383,5 @@
  */
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * @defgroup PJ_MUTEX Mutexes.
@@ -404,5 +404,5 @@
     PJ_MUTEX_DEFAULT,
     PJ_MUTEX_SIMPLE,
-    PJ_MUTEX_RECURSE,
+    PJ_MUTEX_RECURSE
 } pj_mutex_type_e;
 
@@ -501,5 +501,5 @@
  */
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * @defgroup PJ_RW_MUTEX Reader/Writer Mutex
@@ -577,5 +577,5 @@
 
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * @defgroup PJ_CRIT_SEC Critical sections.
@@ -611,5 +611,5 @@
  */
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 #if defined(PJ_HAS_SEMAPHORE) && PJ_HAS_SEMAPHORE != 0
 /**
@@ -680,5 +680,5 @@
 
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 #if defined(PJ_HAS_EVENT_OBJ) && PJ_HAS_EVENT_OBJ != 0
 /**
@@ -772,5 +772,5 @@
 #endif	/* PJ_HAS_EVENT_OBJ */
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * @addtogroup PJ_TIME Time Data Type and Manipulation.
@@ -837,5 +837,5 @@
  */
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 #if defined(PJ_TERM_HAS_COLOR) && PJ_TERM_HAS_COLOR != 0
 
@@ -868,5 +868,5 @@
 #endif	/* PJ_TERM_HAS_COLOR */
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * @defgroup PJ_TIMESTAMP High Resolution Timestamp
@@ -1047,5 +1047,5 @@
 
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * Internal PJLIB function to initialize the threading subsystem.
Index: /pjproject/trunk/pjlib/include/pj/pool.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/pool.h	(revision 621)
+++ /pjproject/trunk/pjlib/include/pj/pool.h	(revision 622)
@@ -313,5 +313,5 @@
  */
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * @defgroup PJ_POOL_FACTORY Pool Factory and Policy.
@@ -527,5 +527,5 @@
  */
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 
 /**
Index: /pjproject/trunk/pjlib/include/pj/sock.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/sock.h	(revision 621)
+++ /pjproject/trunk/pjlib/include/pj/sock.h	(revision 622)
@@ -110,5 +110,5 @@
     PJ_MSG_OOB		= 0x01,	    /**< Out-of-band messages.		 */
     PJ_MSG_PEEK		= 0x02,	    /**< Peek, don't remove from buffer. */
-    PJ_MSG_DONTROUTE	= 0x04,	    /**< Don't route.			 */
+    PJ_MSG_DONTROUTE	= 0x04	    /**< Don't route.			 */
 } pj_sock_msg_flag;
 
@@ -124,5 +124,5 @@
     PJ_SHUT_WR	    = 1,    /**< Alias for SD_SEND.	    */
     PJ_SD_BOTH	    = 2,    /**< No more send and receive.  */
-    PJ_SHUT_RDWR    = 2,    /**< Alias for SD_BOTH.	    */
+    PJ_SHUT_RDWR    = 2     /**< Alias for SD_BOTH.	    */
 } pj_socket_sd_type;
 
@@ -380,5 +380,5 @@
     in_addr.s_addr = pj_ntohl(addr->sin_addr.s_addr);
     return in_addr;
-};
+}
 
 /**
Index: /pjproject/trunk/pjlib/include/pj/types.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/types.h	(revision 621)
+++ /pjproject/trunk/pjlib/include/pj/types.h	(revision 622)
@@ -37,5 +37,5 @@
 PJ_BEGIN_DECL
 
-///////////////////////////////////////////////////////////////////////////////
+/* ************************************************************************* */
 
 /** Unsigned 32bit integer. */
@@ -104,5 +104,5 @@
 #endif
 
-///////////////////////////////////////////////////////////////////////////////
+/* ************************************************************************* */
 /*
  * Data structure types.
@@ -231,5 +231,5 @@
 typedef PJ_ATOMIC_VALUE_TYPE pj_atomic_value_t;
  
-///////////////////////////////////////////////////////////////////////////////
+/* ************************************************************************* */
 
 /** Thread handle. */
@@ -269,5 +269,5 @@
 typedef int pj_exception_id_t;
 
-///////////////////////////////////////////////////////////////////////////////
+/* ************************************************************************* */
 
 /** Utility macro to compute the number of elements in static array. */
@@ -282,5 +282,5 @@
 #define PJ_MAX_OBJ_NAME	16
 
-///////////////////////////////////////////////////////////////////////////////
+/* ************************************************************************* */
 /*
  * General.
@@ -498,5 +498,5 @@
  */
 
-///////////////////////////////////////////////////////////////////////////////
+/* ************************************************************************* */
 /*
  * Terminal.
Index: /pjproject/trunk/pjmedia/include/pjmedia-codec/types.h
===================================================================
--- /pjproject/trunk/pjmedia/include/pjmedia-codec/types.h	(revision 621)
+++ /pjproject/trunk/pjmedia/include/pjmedia-codec/types.h	(revision 622)
@@ -49,5 +49,5 @@
     PJMEDIA_RTP_PT_L16_32KHZ_STEREO,		/**< L16 @ 32KHz, stereo    */
     PJMEDIA_RTP_PT_L16_48KHZ_MONO,		/**< L16 @ 48KHz, mono	    */
-    PJMEDIA_RTP_PT_L16_48KHZ_STEREO,		/**< L16 @ 48KHz, stereo    */
+    PJMEDIA_RTP_PT_L16_48KHZ_STEREO		/**< L16 @ 48KHz, stereo    */
 };
 
Index: /pjproject/trunk/pjmedia/include/pjmedia/clock.h
===================================================================
--- /pjproject/trunk/pjmedia/include/pjmedia/clock.h	(revision 621)
+++ /pjproject/trunk/pjmedia/include/pjmedia/clock.h	(revision 622)
@@ -63,5 +63,5 @@
      * #pjmedia_clock_wait() in order to synchronize timing.
      */
-    PJMEDIA_CLOCK_NO_ASYNC  = 1,
+    PJMEDIA_CLOCK_NO_ASYNC  = 1
 };
 
Index: /pjproject/trunk/pjmedia/include/pjmedia/codec.h
===================================================================
--- /pjproject/trunk/pjmedia/include/pjmedia/codec.h	(revision 621)
+++ /pjproject/trunk/pjmedia/include/pjmedia/codec.h	(revision 622)
@@ -221,5 +221,5 @@
     PJMEDIA_RTP_PT_H263 = 34,	    /**< video H263			    */
 
-    PJMEDIA_RTP_PT_DYNAMIC = 96,    /**< start of dynamic RTP payload	    */
+    PJMEDIA_RTP_PT_DYNAMIC = 96     /**< start of dynamic RTP payload	    */
 
 };
@@ -576,5 +576,5 @@
      * query functions.
      */
-    PJMEDIA_CODEC_PRIO_DISABLED = 0,
+    PJMEDIA_CODEC_PRIO_DISABLED = 0
 
 } pjmedia_codec_priority;
Index: /pjproject/trunk/pjmedia/include/pjmedia/conference.h
===================================================================
--- /pjproject/trunk/pjmedia/include/pjmedia/conference.h	(revision 621)
+++ /pjproject/trunk/pjmedia/include/pjmedia/conference.h	(revision 622)
@@ -72,5 +72,5 @@
     PJMEDIA_CONF_NO_DEVICE = 2,	/**< Do not create sound device.	    */
     PJMEDIA_CONF_SMALL_FILTER=4,/**< Use small filter table when resampling */
-    PJMEDIA_CONF_USE_LINEAR=8,	/**< Use linear resampling instead of filter
+    PJMEDIA_CONF_USE_LINEAR=8	/**< Use linear resampling instead of filter
 				     based.				    */
 };
Index: /pjproject/trunk/pjmedia/include/pjmedia/port.h
===================================================================
--- /pjproject/trunk/pjmedia/include/pjmedia/port.h	(revision 621)
+++ /pjproject/trunk/pjmedia/include/pjmedia/port.h	(revision 622)
@@ -256,5 +256,5 @@
      * Enable TX and RX to/from this port.
      */
-    PJMEDIA_PORT_ENABLE,
+    PJMEDIA_PORT_ENABLE
 };
 
@@ -293,5 +293,5 @@
     PJMEDIA_FRAME_TYPE_NONE,	    /**< No frame.		*/
     PJMEDIA_FRAME_TYPE_CNG,	    /**< Silence audio frame.	*/
-    PJMEDIA_FRAME_TYPE_AUDIO,	    /**< Normal audio frame.	*/
+    PJMEDIA_FRAME_TYPE_AUDIO	    /**< Normal audio frame.	*/
 
 } pjmedia_frame_type;
Index: /pjproject/trunk/pjmedia/include/pjmedia/resample.h
===================================================================
--- /pjproject/trunk/pjmedia/include/pjmedia/resample.h	(revision 621)
+++ /pjproject/trunk/pjmedia/include/pjmedia/resample.h	(revision 622)
@@ -140,5 +140,5 @@
      * Do not destroy downstream port when resample port is destroyed.
      */
-    PJMEDIA_RESAMPLE_DONT_DESTROY_DN = 4,
+    PJMEDIA_RESAMPLE_DONT_DESTROY_DN = 4
 };
 
Index: /pjproject/trunk/pjmedia/include/pjmedia/sdp_neg.h
===================================================================
--- /pjproject/trunk/pjmedia/include/pjmedia/sdp_neg.h	(revision 621)
+++ /pjproject/trunk/pjmedia/include/pjmedia/sdp_neg.h	(revision 622)
@@ -273,5 +273,5 @@
      * successfully or not.
      */
-    PJMEDIA_SDP_NEG_STATE_DONE,
+    PJMEDIA_SDP_NEG_STATE_DONE
 };
 
Index: /pjproject/trunk/pjmedia/include/pjmedia/transport_udp.h
===================================================================
--- /pjproject/trunk/pjmedia/include/pjmedia/transport_udp.h	(revision 621)
+++ /pjproject/trunk/pjmedia/include/pjmedia/transport_udp.h	(revision 622)
@@ -52,5 +52,5 @@
      * Specifying this option will disable this feature.
      */
-    PJMEDIA_UDP_NO_SRC_ADDR_CHECKING = 1,
+    PJMEDIA_UDP_NO_SRC_ADDR_CHECKING = 1
 };
 
Index: /pjproject/trunk/pjmedia/include/pjmedia/types.h
===================================================================
--- /pjproject/trunk/pjmedia/include/pjmedia/types.h	(revision 621)
+++ /pjproject/trunk/pjmedia/include/pjmedia/types.h	(revision 622)
@@ -64,5 +64,5 @@
      *  encoding_name.
      */
-    PJMEDIA_TYPE_UNKNOWN = 3,
+    PJMEDIA_TYPE_UNKNOWN = 3
 
 } pjmedia_type;
@@ -85,5 +85,5 @@
 
     /** Incoming and outgoing stream. */
-    PJMEDIA_DIR_ENCODING_DECODING = 3,
+    PJMEDIA_DIR_ENCODING_DECODING = 3
 
 } pjmedia_dir;
Index: /pjproject/trunk/pjmedia/include/pjmedia/wav_port.h
===================================================================
--- /pjproject/trunk/pjmedia/include/pjmedia/wav_port.h	(revision 621)
+++ /pjproject/trunk/pjmedia/include/pjmedia/wav_port.h	(revision 622)
@@ -47,5 +47,5 @@
      * file has been played.
      */
-    PJMEDIA_FILE_NO_LOOP = 1,
+    PJMEDIA_FILE_NO_LOOP = 1
 };
 
Index: /pjproject/trunk/pjsip/include/pjsip/sip_auth.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsip/sip_auth.h	(revision 621)
+++ /pjproject/trunk/pjsip/include/pjsip/sip_auth.h	(revision 622)
@@ -51,5 +51,5 @@
 {
     PJSIP_CRED_DATA_PLAIN_PASSWD,   /**< Plain text password.	*/
-    PJSIP_CRED_DATA_DIGEST,	    /**< Hashed digest.		*/
+    PJSIP_CRED_DATA_DIGEST	    /**< Hashed digest.		*/
 } pjsip_cred_data_type;
 
@@ -60,5 +60,5 @@
     PJSIP_AUTH_QOP_AUTH,	    /**< Authentication. */
     PJSIP_AUTH_QOP_AUTH_INT,	    /**< Authentication with integrity protection. */
-    PJSIP_AUTH_QOP_UNKNOWN,	    /**< Unknown protection. */
+    PJSIP_AUTH_QOP_UNKNOWN	    /**< Unknown protection. */
 } pjsip_auth_qop_type;
 
Index: /pjproject/trunk/pjsip/include/pjsip/sip_dialog.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsip/sip_dialog.h	(revision 621)
+++ /pjproject/trunk/pjsip/include/pjsip/sip_dialog.h	(revision 622)
@@ -77,5 +77,5 @@
  * Dialog state.
  */
-enum pjsip_dialog_state
+typedef enum pjsip_dialog_state
 {
     /** Dialog is not established. */
@@ -83,6 +83,6 @@
 
     /** Dialog has been established (probably early) */
-    PJSIP_DIALOG_STATE_ESTABLISHED,
-};
+    PJSIP_DIALOG_STATE_ESTABLISHED
+} pjsip_dialog_state;
 
 /**
Index: /pjproject/trunk/pjsip/include/pjsip/sip_event.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsip/sip_event.h	(revision 621)
+++ /pjproject/trunk/pjsip/include/pjsip/sip_event.h	(revision 622)
@@ -60,5 +60,5 @@
 
     /** Indicates that the event was triggered by user action. */
-    PJSIP_EVENT_USER,
+    PJSIP_EVENT_USER
 
 } pjsip_event_id_e;
Index: /pjproject/trunk/pjsip/include/pjsip/sip_module.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsip/sip_module.h	(revision 621)
+++ /pjproject/trunk/pjsip/include/pjsip/sip_module.h	(revision 622)
@@ -208,5 +208,5 @@
      * This is the recommended priority to be used by applications.
      */
-    PJSIP_MOD_PRIORITY_APPLICATION	= 64,
+    PJSIP_MOD_PRIORITY_APPLICATION	= 64
 };
 
Index: /pjproject/trunk/pjsip/include/pjsip/sip_msg.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsip/sip_msg.h	(revision 621)
+++ /pjproject/trunk/pjsip/include/pjsip/sip_msg.h	(revision 622)
@@ -38,5 +38,5 @@
  */
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * @defgroup PJSIP_MSG_METHOD Methods
@@ -61,5 +61,5 @@
     PJSIP_OPTIONS_METHOD,   /**< OPTIONS method.			    */
 
-    PJSIP_OTHER_METHOD,	    /**< Other method.				    */
+    PJSIP_OTHER_METHOD	    /**< Other method.				    */
 
 } pjsip_method_e;
@@ -154,5 +154,5 @@
  */
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /** 
  * @defgroup PJSIP_MSG_HDR Header Fields
@@ -219,5 +219,5 @@
     PJSIP_H_WWW_AUTHENTICATE,
 
-    PJSIP_H_OTHER,
+    PJSIP_H_OTHER
 
 } pjsip_hdr_e;
@@ -335,5 +335,5 @@
  */
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * @defgroup PJSIP_MSG_LINE Request and Status Line.
@@ -433,6 +433,6 @@
 
     PJSIP_SC_TSX_TIMEOUT = 701,
-    //PJSIP_SC_TSX_RESOLVE_ERROR = 702,
-    PJSIP_SC_TSX_TRANSPORT_ERROR = 703,
+    /*PJSIP_SC_TSX_RESOLVE_ERROR = 702,*/
+    PJSIP_SC_TSX_TRANSPORT_ERROR = 703
 
 } pjsip_status_code;
@@ -461,5 +461,5 @@
  */
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * @addtogroup PJSIP_MSG_MEDIA Media/MIME Type
@@ -484,5 +484,5 @@
  */
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * @addtogroup PJSIP_MSG_BODY Message Body
@@ -653,5 +653,5 @@
  */
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * @defgroup PJSIP_MSG_MSG Message Structure
@@ -667,5 +667,5 @@
 {
     PJSIP_REQUEST_MSG,	    /**< Indicates request message. */
-    PJSIP_RESPONSE_MSG,	    /**< Indicates response message. */
+    PJSIP_RESPONSE_MSG	    /**< Indicates response message. */
 } pjsip_msg_type_e;
 
@@ -845,5 +845,5 @@
  */
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * @addtogroup PJSIP_MSG_HDR
@@ -905,5 +905,5 @@
 
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 
 /**
@@ -955,5 +955,5 @@
 							    int value );
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 
 /** Maximum elements in the header array. */
@@ -1008,5 +1008,5 @@
 
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 
 /** Accept header. */
@@ -1043,5 +1043,5 @@
 
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 
 /**
@@ -1078,5 +1078,5 @@
 						void *mem );
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 
 /**
@@ -1119,5 +1119,5 @@
 
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * Content-Length header.
@@ -1155,5 +1155,5 @@
 
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * CSeq header.
@@ -1191,5 +1191,5 @@
 					      void *mem );
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * Contact header.
@@ -1235,5 +1235,5 @@
 
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * Content-Type.
@@ -1271,5 +1271,5 @@
 						void *mem );
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /** Expires header. */
 typedef pjsip_generic_int_hdr pjsip_expires_hdr;
@@ -1307,5 +1307,5 @@
 
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * To or From header.
@@ -1392,5 +1392,5 @@
 
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * Max-Forwards header.
@@ -1429,5 +1429,5 @@
 
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * Min-Expires header.
@@ -1467,5 +1467,5 @@
 
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * Record-Route and Route headers.
@@ -1551,5 +1551,5 @@
 PJ_DECL(pjsip_route_hdr*)   pjsip_routing_hdr_set_route( pjsip_routing_hdr *r );
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * Require header.
@@ -1584,5 +1584,5 @@
 
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * Retry-After header.
@@ -1616,5 +1616,5 @@
 
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * Supported header.
@@ -1643,5 +1643,5 @@
 							void *mem );
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * Unsupported header.
@@ -1670,5 +1670,5 @@
 							    void *mem );
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * SIP Via header.
@@ -1712,5 +1712,5 @@
 					    void *mem );
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /**
  * SIP Warning header.
@@ -1753,5 +1753,5 @@
 				      pj_status_t status);
 
-///////////////////////////////////////////////////////////////////////////////
+/* **************************************************************************/
 /** Accept-Encoding header. */
 typedef pjsip_generic_string_hdr pjsip_accept_encoding_hdr;
@@ -1877,5 +1877,5 @@
 
 /**
- * @}  // PJSIP_MSG
+ * @}  PJSIP_MSG
  */
 
Index: /pjproject/trunk/pjsip/include/pjsip/sip_parser.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsip/sip_parser.h	(revision 621)
+++ /pjproject/trunk/pjsip/include/pjsip/sip_parser.h	(revision 622)
@@ -55,5 +55,5 @@
      *  are treated as header parameters (not URI parameters).
      */
-    PJSIP_PARSE_URI_IN_FROM_TO_HDR = 2,
+    PJSIP_PARSE_URI_IN_FROM_TO_HDR = 2
 };
 
@@ -355,5 +355,5 @@
 enum
 {
-    PJSIP_PARSE_REMOVE_QUOTE = 1,
+    PJSIP_PARSE_REMOVE_QUOTE = 1
 };
 
Index: /pjproject/trunk/pjsip/include/pjsip/sip_transaction.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsip/sip_transaction.h	(revision 621)
+++ /pjproject/trunk/pjsip/include/pjsip/sip_transaction.h	(revision 622)
@@ -69,5 +69,5 @@
     PJSIP_TSX_STATE_TERMINATED,	/**< For UAS/UAC, before it's destroyed.    */
     PJSIP_TSX_STATE_DESTROYED,	/**< For UAS/UAC, will be destroyed now.    */
-    PJSIP_TSX_STATE_MAX,	/**< Number of states.			    */
+    PJSIP_TSX_STATE_MAX		/**< Number of states.			    */
 } pjsip_tsx_state_e;
 
Index: /pjproject/trunk/pjsip/include/pjsip/sip_transport.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsip/sip_transport.h	(revision 621)
+++ /pjproject/trunk/pjsip/include/pjsip/sip_transport.h	(revision 622)
@@ -63,5 +63,5 @@
     PJSIP_TRANSPORT_RELIABLE	    = 1,    /**< Transport is reliable.	    */
     PJSIP_TRANSPORT_SECURE	    = 2,    /**< Transport is secure.	    */
-    PJSIP_TRANSPORT_DATAGRAM	    = 4,    /**< Datagram based transport.  
+    PJSIP_TRANSPORT_DATAGRAM	    = 4     /**< Datagram based transport.  
 					         (it's also assumed to be 
 						 connectionless)	    */
Index: /pjproject/trunk/pjsip/include/pjsip/sip_types.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsip/sip_types.h	(revision 621)
+++ /pjproject/trunk/pjsip/include/pjsip/sip_types.h	(revision 622)
@@ -80,5 +80,5 @@
 
     /** Loopback (datagram, unreliable) */
-    PJSIP_TRANSPORT_LOOP_DGRAM,
+    PJSIP_TRANSPORT_LOOP_DGRAM
 
 } pjsip_transport_type_e;
@@ -163,9 +163,4 @@
 
 /**
- * Dialog state (sip_dialog.h).
- */
-typedef enum pjsip_dialog_state pjsip_dialog_state;
-
-/**
  * Transaction role.
  */
@@ -178,5 +173,5 @@
 
     PJSIP_UAC_ROLE = PJSIP_ROLE_UAC,	/**< Role is UAC. */
-    PJSIP_UAS_ROLE = PJSIP_ROLE_UAS,	/**< Role is UAS. */
+    PJSIP_UAS_ROLE = PJSIP_ROLE_UAS	/**< Role is UAS. */
 
 } pjsip_role_e;
Index: /pjproject/trunk/pjsip/include/pjsip/sip_uri.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsip/sip_uri.h	(revision 621)
+++ /pjproject/trunk/pjsip/include/pjsip/sip_uri.h	(revision 622)
@@ -145,5 +145,5 @@
     PJSIP_URI_IN_CONTACT_HDR,	/**< The URI is in Contact header. */
     PJSIP_URI_IN_ROUTING_HDR,	/**< The URI is in Route/Record-Route header. */
-    PJSIP_URI_IN_OTHER,		/**< Other context (web page, business card, etc.) */
+    PJSIP_URI_IN_OTHER		/**< Other context (web page, business card, etc.) */
 } pjsip_uri_context_e;
 